library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_textio.all;
--use ieee.std_logic_unsigned.all;

use std.textio.all;

entity ROM is
  
  generic (
    load_file_name : string := "RomCfgFile.txt";
    datalength : integer := 32);

  port (
    sel     : in  std_logic;
    address : in  std_logic_vector;
    data    : out std_logic_vector(datalength - 1 downto 0));

end ROM;

architecture behavioral of ROM is

begin  -- behavioral

  rom : process (address, sel)
    type RAMType is array (0 to 2**address'length - 1)
      of std_logic_vector(data'range);
    variable mem : RAMType := (others => (others => '0'));

--    type text is file of string;
    file inFile       : text open read_mode is load_file_name;
    variable buff     : line;
    variable good     : boolean;
    variable length   : integer;
    variable tmp_data : std_logic_vector(data'range);
    variable index    : integer;
  begin  -- process rom
    index := 0;
    while not endfile(inFile) loop
      readline(inFile, buff);
      hread(buff, mem(index));
--      mem(index) = tmp_data;
      index      := index + 1;
    end loop;

    if sel = '1' then
      data <= mem(to_integer(unsigned(address)));
    else
      data <= (others => '0');
    end if;
    
  end process rom;

end behavioral;
