-------------------------------------------------------------------------------
-- Title      : Simple testbench of the syncDelay module
-- Project    : 
-------------------------------------------------------------------------------
-- File       : syncDelayTb.vhd
-- Author     :   <otger@PWOTGER>
-- Company    : 
-- Created    : 2009-01-19
-- Last update: 2009-01-19
-- Platform   : 
-- Standard   : VHDL'87
-------------------------------------------------------------------------------
-- Description: 
-------------------------------------------------------------------------------
-- Copyright (c) 2009 
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2009-01-19  1.0      otger	Created
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity syncDelayTb is
  
end syncDelayTb;

architecture behavioral of syncDelayTb is
  component syncDelay
    port (
      sysclk      : in  std_logic;
      reset       : in  std_logic;
      write       : in  std_logic;
      delayDatIn  : in  std_logic_vector(7 downto 0);
      delayDatOut : out std_logic_vector(7 downto 0);
      delChipClk  : out std_logic;
      delChipD    : out std_logic;
      delChipE    : out std_logic);
  end component;
  signal sysclk      : std_logic;
  signal reset       : std_logic;
  signal write       : std_logic;
  signal delayDatIn  : std_logic_vector(7 downto 0);
  signal delayDatOut : std_logic_vector(7 downto 0);
  signal delChipClk  : std_logic;
  signal delChipD    : std_logic;
  signal delChipE    : std_logic;
begin  -- behavioral

  process
  begin  -- process
    sysclk <= '0';
    wait for 12.5 ns;
    sysclk <= '1';
    wait for 12.5 ns;
  end process;

  process
  begin  -- process
    reset <= '1';
    write <= '0';
    delayDatIn <= x"00";
    wait until sysclk = '1';
    reset <= '0';
    wait until sysclk = '1';

    delayDatIn <= x"aa";
    write <= '1';
    wait until sysclk = '1';
    write <= '0';
    
    wait;
  end process;
  
  syncDelay_1: syncDelay
    port map (
      sysclk      => sysclk,
      reset       => reset,
      write       => write,
      delayDatIn  => delayDatIn,
      delayDatOut => delayDatOut,
      delChipClk  => delChipClk,
      delChipD    => delChipD,
      delChipE    => delChipE);

end behavioral;
